<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link href="/css/style.css" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bulma/0.5.0/css/bulma.min.css">
    <script src="https://www.gstatic.com/firebasejs/4.2.0/firebase.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/vue/2.4.2/vue.min.js"></script>
    <!--<script src="/lib/store.js"></script>-->
    <script src="/lib/md5.js"></script>
    <!-- Primary Meta Tags -->
    <title>Video con clave 🔒</title>
    <meta name="title" content="Video con clave 🔒">
    <meta name="description" content="Escribe la clave para acceder al video.">

    <!-- Open Graph / Facebook -->
    <meta property="og:type" content="website">
    <meta property="og:title" content="Video con clave 🔒">
    <meta property="og:description" content="Escribe la clave para acceder al video.">
    <meta property="og:image" content="https://link-privado.web.app/play.png">

    <!-- Twitter -->
    <meta property="twitter:card" content="summary_large_image">
    <meta property="twitter:title" content="Video con clave 🔒">
    <meta property="twitter:description" content="Escribe la clave para acceder al video.">
    <meta property="twitter:image" content="https://link-privado.web.app/play.png">
    <script>
      // Initialize Firebase
      var config = {
        apiKey: "AIzaSyC8R9zydYTTjq6u6I1icQsrTEavX2OEIQU",
        authDomain: "link-privado.firebaseapp.com",
        databaseURL: "https://link-privado.firebaseio.com",
        projectId: "link-privado",
        storageBucket: "link-privado.appspot.com",
        messagingSenderId: "1094658108415",
        appId: "1:1094658108415:web:3d0b6f8137639f6b9655ca"
      };
      firebase.initializeApp(config);
    </script>
  </head>
  <body>
    <section class="hero">
      <div class="hero-body">
        <div class="container">
          <h1 class="title">🔒</h1>
          <!--<h2 class="subtitle">crear</h2>-->
        </div>
      </div>
    </section>
    <div id="app" class="container">
      <form @submit.prevent="onSubmit" id="digilock" action="#">
        <div class="field">
          <label class="label" for="link">Link de YouTube</label>
          <div class="control">
            <input required class="input" type="url" name="link">
          </div>
        </div>
        <div class="field">
          <label class="label" for="title">Titulo</label>
          <div class="control">
            <input class="input" type="title" name="title">
          </div>
        </div>
        <div class="field">
          <div class="control">
            <label class="label" for="codes">Codigos</label>
            <textarea required class="textarea" name="codes" placeholder="Codigos (1 por linea)" v-model="codesPerLine"></textarea>
          </div>
        </div>
        <p>Generar codigos aleatorios (opcional)</p>
        <div class="field has-addons">
          <div class="control">
            <input v-model="ngencode" class="input" type="number">
          </div>
          <div class="control">
            <a @click="addCodes" class="button">
              Agregar
            </a>
          </div>
        </div>
        <div class="field">
          <label class="label" for="logo">Logo (optional)</label>
          <div class="control">
            <input class="input" type="url" name="logo" placeholder="URL">
          </div>
        </div>
        <div class="field">
          <div class="control">
            <button class="button is-primary">Crear link privado</button>
            <strong v-if="lock">
              URL privada: <a :href="lock" target="_blank">{{ lock }}</a>
            </strong>
          </div>
        </div>
      </form><br><br>
    </div>

    <script>
      function getQueryVariable(link, variable) {
        var query = link.split('?')[1];
        var vars = query.split('&');
        for (var i = 0; i < vars.length; i++) {
            var pair = vars[i].split('=');
            if (decodeURIComponent(pair[0]) == variable) {
                return decodeURIComponent(pair[1]);
            }
        }
        console.log('Query variable %s not found', variable);
      }

      var db = firebase.database().ref('locks');

      var app = new Vue({
        el: '#app',
        data: {
          ngencode: 5,
          codes: [],
          codesPerLine: "",
          lock: ""
        },
        methods: {
          addCodes: function(e) {
            this.codes = [];
            for (var i=0; i < this.ngencode; i++) {
              var code = genCode();
              this.codes.push(code);
            }
            this.codesPerLine = this.codes.join('\n');
          },
          onSubmit: function() {
            var self = this;
            var form = document.forms.digilock;
            var id = genCode();
            var obj = {
              link: `https://youtube.com/embed/${this.getYoutubeID(form.elements.link.value)}`,
              logo: form.elements.logo.value,
              title: form.elements.title.value,
              codes: this.codesPerLine.split('\n')
            }
            console.log(obj)
            this.save(id, obj)
          },
          save (id, obj) {
            var self = this;
            db.child(id).set(obj)
            db.child(id).once('value').then(function(snapshot) {
              console.log(snapshot.val(), snapshot.key, snapshot)
              self.lock = window.location.href + 'l/' + id;
              console.log(self.lock)
            })
          },
          getYoutubeID(link) {
            if (link.includes("youtu.be/")) {
              return link.split("/").slice(-1).pop()
            } else {
              return getQueryVariable(link, 'v')
            }
          }
        }
      })

      function genCode() {
        var text = "";
        var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        for (var i = 0; i < 5; i++)
          text += possible.charAt(Math.floor(Math.random() * possible.length));
        return text;
      }
      </script>
  </body>
</html>

